#
#  Communication Server module for Correlator 
#  @Auther: by M.Sekido 
#  @Date:  2007.5.18 
#
#
package Cor_com_srv;
use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
#use lib "$ENV{HOME}/prog/perl/module";
use Logsys;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

DESTROY{
}

sub new ($){
    my $pkg = shift;
    my $this = {'lag'=> 32, 'tpp' => 1, 'odir' => ".", 
		'prog' => "cor",  'apdir'=> ".", 'DBG'=>0,
		'integ' => 0, 'stofst'=>0};
    bless $this;
    $this;
}

sub Set_dbg($){
 my $pkg = shift;
 $pkg->{'DBG'}=1;
}

sub Set_logfile($$){
    my ($pkg,$logfile) = @_;
    my $logsys = new Logsys;
    return -1 if($logsys->Set_logfile($logfile) <0);
    $pkg->{logsys}=$logsys;
}

sub Message($$){
    my ($pkg,$msg) = @_;
    return -1 unless(defined($pkg->{logsys}));
    $pkg->{logsys}->Message($msg);
}
 
sub Set_prog($$){
    my ($pkg,$prog) = @_;
    $pkg->{prog}=$prog;
}

sub Cor_prg($){
    my $pkg = shift;
    $pkg->{prog};
}

sub Set_srv_port($$){
    my ($pkg,$port) = @_;
    $pkg->{port}=$port;
}

sub Set_flag($$){
    my ($pkg,$flag) = @_;
    $pkg->{exflag}=$flag;
}

sub Exflag($){
    my $pkg = shift;
    $pkg->{exflag};
}
sub Set_outdir($$){
    my ($pkg,$dir) = @_;
    $pkg->{odir}=$dir;
}
sub Set_aprdir($$){
    my ($pkg,$dir) = @_;
    $pkg->{aprdir}=$dir;
}

sub Set_lag($$){
    my ($pkg,$lag) = @_;
    $pkg->{lag}=$lag;
}
sub Set_Integ($$){
    my ($pkg,$intg) = @_;
    $pkg->{integ}=$intg;
}
sub Set_Stofst($$){
    my ($pkg,$ofst) = @_;
    $pkg->{stofst}=$ofst;
}

sub Set_cor_opt($$){
    my ($pkg,$opt) = @_;
     $pkg->{cor_opt}=$opt;
}
sub Set_flist($$){
    my ($pkg,$flist) = @_;
    $pkg->{list}=$flist;
}

sub Srv_port($){
    my $pkg = shift;
    $pkg->{port};
}

sub Mgrport($){
    my $pkg = shift;
    $pkg->{mgrport};
}

sub Execting_list($){
    my $pkg = shift;
    $pkg->{execting_list};
}

sub Waiting_list($){
    my $pkg = shift;
    $pkg->{waiting_list};
}

sub Mgr_IP($){
    my $pkg = shift;
    $pkg->{mgr_ip};
}

sub Finished_list($){
    my $pkg = shift;
    $pkg->{finished_list};
}

sub Count_entry($){
    my $pkg = shift;
    my $job_entry = $pkg->{job_entry};
    
    undef $pkg->{execting_list};
    undef $pkg->{waiting_list};
    undef $pkg->{finished_list};
#     my $execting_l = $pkg->{execting_list};
#     my $waiting_l   = $pkg->{waiting_list};
#     my $finished_l = $pkg->{finished_list};
    my (@e_list , @w_list, @f_list)=((),(),());
    
    ## Status 2: waiting, 1:executing, 0 finished
    my @cnt = (0,0,0);
    foreach $e (keys(%{$job_entry})){
	if($job_entry->{$e} ==1){ # executing
	    $e_list[$cnt[1]++] = $e;
	}elsif($job_entry->{$e} == 0){ ## Finished 
	    $f_list[$cnt[0]++] = $e;
	}elsif($job_entry->{$e} == 2){ ## Waiting 
	    $w_list[$cnt[2]++] = $e;
	}
    }
    $pkg->{execting_list} = \@e_list;
    $pkg->{waiting_list} = \@w_list;
    $pkg->{finished_list} = \@f_list;
#     print STDERR " Count_entry= @cnt \n";
#     print STDERR "exelist = @e_list\n";
#     print STDERR "want listt = @w_list\n";
#     print STDERR "finish list = @f_list\n";
    @cnt;
}

sub Open_srvSocket($){
 my $pkg = shift;
 my $listening_socket = 
     IO::Socket::INET->new( LocalPort => $pkg->Srv_port(),
			    Listen    => SOMAXCONN,
			    Proto     => 'tcp',
			    Reuse     => 1  );
 unless(defined($listening_socket)){
     print STDERR "Error in creating socket\n";
     printf STDERR " port: %d may be already in use\n", $pkg->Srv_port();
     exit(1); 
 }
 $pkg->{srv_sock} = $listening_socket;
}

sub Job_Entry($){
    my $pkg = shift;
    $pkg->{job_entry};
}


sub Pop_job($){
    my $pkg = shift;
    my $job_entry =  $pkg->{job_entry};
    my $execting_l = $pkg->{execting_list};
    my $waiting_l   = $pkg->{waiting_list};
    my $finished_l = $pkg->{finished_list};
    if(defined($execting_l) && @$execting_l > 0){
	printf STDERR "Error in Cor_com_srv::Pop_job(): Stil job (%s) is running \n",
	$$execting_l[0];
	exit(1);
    }
    my $nx = shift(@{$waiting_l});
    push(@{$execting_l},($nx));
    $job_entry->{$nx} = 1;
    $pkg->{job_entry} = $job_entry;
#    my @terms = split(/:/,$nx);
#    my $apfile = sprintf "%s%s%s.txt", $terms[0],$terms[1], $terms[2];
    my @terms = split(m![/\-:]!,$nx);
    my $apfile = sprintf "ape%03d%02d%02d%02d%s%s.txt", 
    $terms[1],$terms[2], $terms[3],$terms[4],$terms[5],$terms[6];
    my $lag = $pkg->{lag};
    my $integ = $pkg->{integ};
    my $st_ofst = $pkg->{stofst};
    my $odir = $pkg->{odir};
    my $tpp = $pkg->{tpp};
    my $prog = $pkg->{prog};
    my $apdir = $pkg->{aprdir};
    my $opt2 = $pkg->{cor_opt};
    my $opt = "-lag $lag -odir $odir -t1pp $tpp -integ $integ -soffset $st_ofst";
    $opt = $opt . " $opt2" if(defined($opt2));

    my $cmd = "$prog $apdir/$apfile $opt ";
    $pkg->Message( "Cmd: ($cmd) will be issued.");
    return ($cmd, $nx); 
}

sub Job_end($){
    my $pkg = shift;
    my $exe_l = $pkg->{execting_list};
    my $job_e =  $pkg->{job_entry};
    $job_e->{$$exe_l[0]} = 0;
    $pkg->{job_entry} = $job_e;
    $pkg->Count_entry();
}

sub Wait_connection($){
    my $pkg = shift;

    $job_entry = $pkg->{job_entry};
    my $entry;

    # Waiting until connection is established 
    my $new_socket = $pkg->{srv_sock}->accept();
    unless(defined($new_socket)){
	print STDERR "Srv Sock Timeout\n";
	return -1;
    }
    
    my $client_sockaddr = $new_socket->peername();
    my ($client_port,$client_iaddr) = unpack_sockaddr_in($client_sockaddr);
    my $client_hostname = gethostbyaddr($client_iaddr, AF_INET);
    my $client_ip = $pkg->{mgr_ip} = inet_ntoa($client_iaddr);

    if(defined($client_hostname)){
	print STDERR "Connected from: $client_hostname($client_ip) Port: $client_port\n" 
	    if($pkg->{'DBG'});
	$pkg->Message("Connected from: $client_hostname($client_ip) Port: $client_port\n");
    }else{
	print STDERR "Connected from: host:unknown ($client_ip) Port: $client_port\n"
	    if($pkg->{'DBG'});
	$pkg->Message("Connected from: host:unkhown ($client_ip) Port: $client_port\n");
    }
    select($new_socket); $|=1; # stop buffering 
    select(STDOUT);

    while (<$new_socket>){
	chomp;
	printf STDERR "Received Message: %s \n", $_ if($pkg->{'DBG'});
	## Expecting message like "2007/138-00:00:00 OT a"
	my @job_cnt = $pkg->Count_entry();
	my $ex_list = $pkg->{execting_list};
	
	if(m!Scan:\s*(\d{4}/\d{3}-\d\d:\d\d:\d\d)\s+(\S+)\s+(\S+)!){
	    if($job_cnt[1]>0){ ## Still job is running 
		printf STDERR "Refuse job, since other job(%s) is running,\n",
		    $$ex_list[0];
		$pkg->Message("Refuse job, since other job($$ex_list[0]) is running,\n");
		print $new_socket "NG:$_\n";
		last;
	    }
	    print $new_socket "OK: $_\n";
	    my $time_str = $1;
	    my $stid = $2;
	    my $gid = $3;
	    my @terms = split(m![:/-]!,$time_str);
#	    $entry= sprintf "ape%03d%02d%02d%02d:$stid:$gid",
#	    $terms[1],$terms[2],$terms[3],$terms[4];
	    $entry= "$time_str:$stid:$gid";
	    print STDERR "Job Entry: $entry received\n";
	    $pkg->Message("Job Entry: $entry received\n");
	    $job_entry->{$entry} = 2;  # Staus is waiting 
	    $pkg->{job_entry} = $job_entry;
	    last;
	}elsif(/Jobs\?/){
	    printf $new_socket "Jobs: %d %d %d\n",
	    $job_cnt[0], $job_cnt[1], $job_cnt[2]; 
	    printf STDERR "Jobs: %d %d %d\n",
	    $job_cnt[0], $job_cnt[1], $job_cnt[2]; 
	    next;
	}elsif(/JobsList\?/){
	    my $fns = join(" ",@{$pkg->Finished_list()});
	    my $exn = join(" ",@{$pkg->Execting_list()});
	    my $wit = join(" ",@{$pkg->Waiting_list()});
	    if($pkg->{'DBG'}){
		printf STDERR "Finished: %s\n",$fns; 
		printf STDERR "Waiting: %s\n",$wit;
		printf STDERR "Executing: %s\n",$exn;
	    }
	    printf $new_socket "Finished: %s\n",$fns;
	    printf $new_socket "Waiting: %s\n",$wit;
	    printf $new_socket "Executing: %s\n",$exn;
	    next;
	}elsif(/Lag:\s*(\d+)/){
	    my $lag =$1;
	    printf STDERR "Lag setup to     :%d\n", $lag;
	    $pkg->Set_lag($lag);
	    next;
	}elsif(/Integ:\s*(\d+)/){
	    my $integ =$1;
	    printf STDERR "Integ time setup :%d sec\n", $integ;
	    $pkg->Set_Integ($integ);
	    next;
	}elsif(/Stofst:\s*(\d+)/){
	    my $ofst =$1;
	    printf STDERR "Stofst setup to  :%d sec\n", $ofst;
	    $pkg->Set_Stofst($ofst);
	    next;
	}elsif(m!Aprdir:\s*(\S+)!){
	    my $aprdir = $1;
	    printf STDERR "Aprdir setup to  :%s\n", $aprdir;
	    $pkg->Set_aprdir($aprdir);
	    next;
	}elsif(m!Odir:\s*(\S+)!){
	    my $odir =$1;
	    printf STDERR "Odir setup to    :%s\n", $odir;
	    $pkg->Set_outdir($odir);
	    next;
	}elsif(/CorOpt:\s*(\S+)/){
	    my $opt =$1;
	    printf STDERR "CorOpt setup to  :%s\n", $opt;
	    $pkg->Set_cor_opt($opt);
	    next;
	}elsif(/Prog:\s*(\S+)/){
	    my $prg =$1;
	    printf STDERR "Prog setup to    :%s\n", $prg;
	    $pkg->Set_prog($prg);
	    next;
	}elsif(/Mgrport:\s*(\d+)/){
	    my $mgrport =$1;
	    printf STDERR "Mgrport setup to :%d\n", $mgrport;
	    $pkg->{mgrport} = $mgrport;
	    next;
	}else{
	    printf STDERR "Received Message: %s \n", $_;
	    print STDERR "Warning: message format is unexpected\n";
	    next;
	}
    }
    $new_socket->close();
    
    printf STDERR "Connection Close, Watching port %d.\n",$pkg->{port};
    
    return $entry;
    
}

1;
