package FSlog;
use Exporter;
@ISA = qw(Exporter);

#require "$ENV{HOME}/prog/perl/UTIL/time.pl";
use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;

BEGIN{

}


sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

# in format "yyy[/:]ddd hh:mm:ss"
sub Set_start($$){
    my ($pkg, $st) = @_;
    printf STDOUT " Set Start time=%s \n", $st->Str_fmt1(); 
    $pkg->{st} = $st;
}

sub Read($$){
    my ($pkg, $fname) = @_;
    
    unless( open(IN, "$fname") ){
	print STDERR "E Read(): Failed to open file $fname \n";
	return -1;
    }
    my $st = $pkg->{st};
    my $icnt=-1;
    my (@tarr, @az, @el, @tsysx, @tsyss);
    my $line = <IN>;
    while( ! eof(IN) ){
	next if($line =~/^\"/ ) ;
	unless($line =~/(\d{4})\.(\d{3})\.(\d\d):(\d\d):([\d\.]+)/){
	    print STDERR "E Matching failed: $line\n";
	    next;
	}
	my @ydhms;
	$ydhms[0] = $1;
	$ydhms[1] = $2;
	$ydhms[2] = $3;
	$ydhms[3] = $4;
	$ydhms[4] = $5;
	my $dat = $'; # ';
	my $t1 = new Time_lib;
	$t1->Set_time_ydhms(@ydhms);
	next if( defined($st) && $t1 < $st);
	if($dat =~/source\=azeluncr,([\d\.]+)d,([\d\.]+)d/){
	    $icnt++;
	    $az[$icnt] = $1;
	    $el[$icnt] = $2;
	    $tarr[$icnt] = $t1;
	}elsif($dat =~m!/tsys/u5,([\d\.\$]+)!){
	    $tsysx[$icnt] = $1;
	    if($1 =~ /\$\$/){
		$tsysx[$icnt] = 10000 ;} 
	}elsif($dat =~m!/tsys/u6,([\d\.\$]+)!){
	    $tsyss[$icnt] = $1;
	    if($1 =~ /\$\$/){
		$tsyss[$icnt] = 10000; } 
	}
    }continue{
	$line = <IN>;
    }
    close(IN);

    $pkg->{tsysx} = \@tsysx;
    $pkg->{tsyss} = \@tsyss;
    $pkg->{tarr} = \@tarr;
    $pkg->{az} = \@az;
    $pkg->{el} = \@el;
}

sub EL($){
    $pkg = shift;
    return @{$pkg->{el}};
}

sub AZ($){
    $pkg = shift;
    return @{$pkg->{az}};
}


sub Tarr($){
    $pkg = shift;
    return @{$pkg->{tarr}};
}

sub Tsys($$){
    ($pkg,$band) = @_;
    my $ret;
    if($band == 1){# xband
	return @{$pkg->{tsysx}};
    }elsif($band == 2){# sband
	return @{$pkg->{tsyss}};
    }else{
	print "E \@Tsys(): Unexpected band index($band)\n";
	return undef;
    }
}

1;
