package Pcal_dat2;

use POSIX stdio_h;
# use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;

BEGIN{
}

sub new ($$){
    my ($pkg, $infile) = @_;

    my $this = {'infile' => $infile};
    bless $this;
    $this;
}

sub Open($){
    my $pkg = shift;
    my $in = IN;
    unless(defined($pkg->{infile})){
      print STDERR "Error: data file is not defined\n";
      exit(1);
    }
    unless(open($in,$pkg->{infile})){
	print STDERR "Cannot open file $pkg->{infile} \n";
	return -1;
    }
    $pkg->{in} = $in;
    return 1;
}

sub Close($){
    my $pkg = shift;
    close($pkg->{in});
}

sub Last_time($){
    my $pkg = shift;
#    my @ret = stat($pkg->{infile});
#    print STDERR "filesize = $ret[7] Byte\n";
    my $in =  $pkg->{in};
    seek( $pkg->{in}, -1024, SEEK_END);
    <$in>;
    my $t1 = new Time_lib;
    while(<$in>){
	next if(/^\#/);
	if(m!(\d{4})/(\d{3}) (\d\d):(\d\d):(\d\d)!){
	    $t1->Set_time_ydhms($1,$2,$3,$4,$5);
	}
    }
    $pkg->{t_last} = $t1;
}

sub Seek_pos($$){
    my ($pkg, $pos) = @_;
    my $in = $pkg->{in};
    seek($in,$pos,SEEK_SET); 
}


# whe =0: SEEK_SET 1:SEEK_CUR, 3:SEEK_END
sub Seek_time($$){
    my ($pkg, $t0) = @_;
    my $in = $pkg->{in};
    seek($in,0,SEEK_SET); 

    my $t1 = new Time_lib;
    while(<$in>){
	next if(/^\#/);
	if(m!(\d{4})/(\d{3}) (\d\d):(\d\d):(\d\d)!){
	    $t1->Set_time_ydhms($1,$2,$3,$4,$5);
#	    printf STDERR "t0= %s, t1= %s \n", 
#	    $t0->Str_fmt1(),$t1->Str_fmt1();
	    last if($t0 == $t1 ||  $t0 < $t1 );
	}
    }
    printf STDERR "t0= %s, t1= %s \n", 
    $t0->Str_fmt1(),$t1->Str_fmt1();
    
}

sub Eof($){
    my $pkg = shift;
    eof($pkg->{in});
}

sub Read($){
    my $pkg = shift;
    my (@tarr, $freq, @amp, @phs) = ((),(),(),());
    my $cnt=0;
    my $nch =0;
    my $in = $pkg->{in};
    return -1    if( eof($in));
    while(<$in>){
	next if(/^\#/);
	next unless(m!\d{4}/\d{3}\s+\d\d:\d\d:\d\d.*!);
	
	my @terms = split(m![\s/:]+!);
	my $yy = shift(@terms);
	my $dd = shift(@terms);
	my $hh = shift(@terms);
	my $mm = shift(@terms);
	my $ss = shift(@terms);
	my $t1 = new Time_lib;
	$t1->Set_time_ydhms($yy,$dd,$hh,$mm,$ss);
	$tarr[$cnt] = $t1;
	$nch=0;
	shift(@terms);
	while(@terms){
	    $amp[$nch][$cnt] = shift(@terms);
	    $phs[$nch][$cnt] = shift(@terms);
	    $nch++;	    
	}
	$cnt++;
    }	
    $pkg->{nch} = $nch;
    $pkg->{ndat} = $cnt;
    $pkg->{amp} = \@amp;
    $pkg->{phs} = \@phs;
    $pkg->{tarr} = \@tarr;
    $cnt;
}

sub Ndat($){
    my $pkg = shift;
    $pkg->{ndat};
}

sub Nch($){
    my $pkg = shift;
    $pkg->{nch};
}

sub Tarr($){
    my $pkg = shift;
    @{$pkg->{tarr}};
}

sub Amp($$){
    my ($pkg,$ich) = @_;
    ${$pkg->{amp}}[$ich];
}

sub Phs($$){
    my ($pkg,$ich) = @_;
    ${$pkg->{phs}}[$ich];
}

1;
