package Sdelay_stdout;
# This package reading the data of sdelay output in stdout and analyse it.
#  Coded 2009/7/17
use Exporter;
@ISA = qw(Exporter);
use Time_lib;

@EXPORT = qw(Read);

BEGIN{
    ;
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}


sub Read($$){
    my ($pkg, $file) = @_;
    
    unless(open(IN,$file)){
	print "Error in Sdelay_stdout::Read():Failed to open file ($file)\n";
	return -1;
    } ;

    my $ndat=-1;
    my $idat_cur=$ndat;
    my (  @cout,@xfile,@yfile,@basearr,@src,@prt,@clock,@eop,@frq,@cff,@drsd,
	  @rrsd,@snr,@bit,@srat,@intg,@ulsb);
    while(!eof(IN)){
	my $line = <IN>;
	if($line =~/SUMMARY OUT PUT/){
	    $ndat++; 
	    $idat_cur = $ndat;
	}
	if($line =~/COUT\s+:\s*(\S+)/){$cout[$ndat]=$1 }
	elsif($line =~/X DATA\s+:\s*(\S+)/){ $xfile[$ndat]=$1;}
	elsif($line =~/Y DATA\s+:\s*(\S+)/){$yfile[$ndat]=$1; }
	elsif($line =~/BASELINE\s+:\s*(\S+\s+-\s+\S+)/){$basearr[$ndat]=$1;}
	elsif($line =~/SOURCE\s+:\s*(\S+)\s+SAMPLING\s+:\s*(\d)\s*bit\s+(\d+)\s*MHz/){
	    $src[$ndat]=$1;
	    $bit[$ndat]=$2;
	    $srat[$ndat]=$3;
	}
	elsif($line =~/PRT\s+:\s*(\S+\s+\S+)\s+Tinteg\(s\)\s+:\s*(\d+)/){
	    $prt[$ndat]=$1;
	    $intg[$ndat]=$2;
	}
	elsif($line =~/CLOCK\s+:/){
	    $line=  $';    # ';
	    $line =~m!offset\s+(\S+)\(s\)\s+rate\s+(\S+)\(s/s\)!;
	    my @clk = ($1,$2);
	    $clock[$ndat]=\@clk; }
	elsif($line =~/EOP\s+:/){
	    $line = $'; # ';
	    my @tmp;
	    $line =~/ut1-utc\s*(\S+)\(s\)/; $tmp[0] = $1;
	    $line=<IN>;  $line =~/x-wob\s*(\S+)\(s\)/; $tmp[1] = $1;
	    $line=<IN>;  $line =~/y-wob\s*(\S+)\(s\)/; $tmp[2] = $1;
	    $eop[$ndat] = \@tmp; }
	elsif($line =~/FREQUENCY       AMP MAX     POSITION         RESIDUAL/){
	    for(my $i=0; $i<3; $i++){$line=<IN>;}
	    my $i=0;
	    my (@ch,@f,@ul,@cf,@d,@r,@s);
	    while($i<4 && $line !~/---------------/){
		unless($line =~/(\d)\s+([\d,.]+)\s+([UL])\s+(\S+)\s+\(.*\)\s+(\S+)\s+(\S+)\s+(\S+)/ ){
		    print "Error in reading Freq-corr data: line= ($line) is unexpected form.\n";
		    exit(1);
		}
		$ch[$i]=$1; $f[$i]=$2; $ul[$i]=$3; $cf[$i]=$4;
		$d[$i]=$5; $r[$i]=$6; $s[$i]=$7;
		$line=<IN>;
		$i++;
	    }
	    $frq[$ndat]=\@f;
	    $cff[$ndat]=\@cf;
	    $drsd[$ndat]=\@d;
	    $rrsd[$ndat]=\@r;
	    $snr[$ndat]=\@s;
	    $ulsb[$ndat]=\@ul;
	}
    }
    
    $pkg->{cout}=\@cout;
    $pkg->{xfile}=\@xfile;
    $pkg->{yfile}=\@yfile;
    $pkg->{baseline}=\@basearr;
    $pkg->{source}=\@src;
    $pkg->{prt}=\@prt;
    $pkg->{clock}=\@clock;
    $pkg->{eop}=\@eop;
    $pkg->{frq}=\@frq;
    $pkg->{corcff}=\@cff;
    $pkg->{drsd}=\@drsd;
    $pkg->{rrsd}=\@rrsd;
    $pkg->{snr}=\@snr;
    $pkg->{bit}=\@bit;
    $pkg->{srate}=\@srat;
    $pkg->{ulsb}=\@ulsb;
    $pkg->{tinteg}=\@intg;
    return $ndat+1;

}

sub Cout($$){
    my ($pkg,$i) = @_;
    ${$pkg->{cout}}[$i];
}
sub Xfile($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{xfile}}[$i];
}
sub Yfile($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{yfile}}[$i];
}
sub Baseline($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{baseline}}[$i];
}
sub Source($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{source}}[$i];
}
sub PRT($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{prt}}[$i];
}
sub Bit($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{bit}}[$i];
}
sub Srate($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{srate}}[$i];
}
sub Tintg($){
    my $pkg = shift;
    my $i = shift;
    ${$pkg->{tintg}}[$i];
}
sub Clock($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{clock}}[$i]};
}
sub Eop($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{eop}}[$i]};
}
sub Frq($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{frq}}[$i]};
}
sub CorCff($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{corcff}}[$i]};
}
sub Drsd($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{drsd}}[$i]};
}
sub Rrsd($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{rrsd}}[$i]};
}
sub SNR($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{snr}}[$i]};
}
sub ULsb($){
    my $pkg = shift;
    my $i = shift;
    @{${$pkg->{ulsb}}[$i]};
}

1;
