##  Correlation manager configuration module 
##
package Cor_conf;
use Exporter;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {'prog', "cor",
	    'MON' =>0};
    bless $this;
    $this;
}
sub Set_monit($){
    $pkg=shift;
    $pkg->{'MON'}=1;
}

sub Read_conf($$){
    my ($pkg, $fname) = @_;
    $pkg->{conf} = $fname;
    
    unless(open(IN,$fname)){
	print STDERR 
	    "Error in Cor_conf::Read_conf(): Failed to open conf file $fname.\n";
	return -1;
    }
    my $mode =0;
    my (%stname,%flag_notice); 
    my (@hlist, @baseIDs, @aprdirs, @outdirs);
    while(<IN>){
	if(/\$STATION/){  $mode =1; next;}
	if(/\$BASELINE/){ $mode =2; next;}
	if(/\$GROUP/){    $mode =3; next;}
	if(/\$HOSTS/){    $mode =4; next;}
	if(/\$COR/){      $mode =5; next;}
	if(/\$KOMB_PARM/){$mode =6; next;}
	if(/\$SKED/){     $mode =7; next;}
	if(/\$Version\s+(\d+)/){$pkg->{Version} = $1;}
	next if(/^\#/);
	if($mode==1){ ## Station 
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    next if(@terms==0);
	    $stnamme{$terms[1]} = $terms[0];
	    $flag_notice{$terms[1]} = $terms[2];
	}elsif($mode==2){ ## Baseline 
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    next if(@terms==0);
	    unless(/:/){ ## Version 1 (Single Baseline)
		$pkg->{baseids} = \@terms;
	    }else{ ## Version 2 (multi baseline)
		foreach $t (@terms){
		    if($t =~/Base:(\S+)/){
			push(@baseIDs,($1));
		    }elsif($t =~m!Aprdir:(\S+)!){
			push(@aprdirs,($1));
		    }elsif($t =~m!Odir:(\S+)!){
			push(@outdirs,($1));
		    }
		}
	    }
	}elsif($mode==3){ ## Group 
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    next if(@terms==0);
	    $pkg->{grpid} = \@terms;
	}elsif($mode==4){ ## Hosts
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    next if(@terms==0);
	    push(@hlist,@terms);
	}elsif($mode==5){ ## Cor
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    foreach $t (@terms){
		if($t =~/LAG:(\d+)/){
		    $pkg->{lag} = $1;
		}elsif($t =~/TPP:(\d+)/){
		    $pkg->{tpp} = $1;
		}elsif($t =~/INTEG:(\d+)/){
		    $pkg->{integ} = $1;
		}elsif($t =~/ST_OFFSET:(\d+)/){
		    $pkg->{stofst} = $1;
		}elsif($t =~m!Aprdir:(\S+)!){
		    $pkg->{aprdir} = $1;
		}elsif($t =~m!Odir:(\S+)!){
		    $pkg->{odir} = $1;
		}elsif($t =~m!PROG:(\S+)!){
		    $pkg->{prog} = $1;
		}
	    }
	}elsif($mode==6){ ## KOMB_PARM
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    foreach $t (@terms){
		if($t =~/PROG:\s*(\S+)/){
		    $pkg->{komb_prog} = $1;
		}elsif($t =~m!KOMB_OUT_DIR:\s*(\S+)!){
		    $pkg->{komb_out_dir} = $1;
		}elsif($t =~m!Band:\s*(\S+)!){
		    $pkg->{komb_band} = $1;
		}elsif($t =~m!WORK_DIR:\s*(\S+)!){
		    $pkg->{komb_work_dir} = $1;
		}elsif($t =~m!OPT:!){
		    $pkg->{komb_opt} = $'; # '
		}
	    }
	}elsif($mode==7){ ## SKED
	    /\s*/;
	    my @terms = split(/\s+/,$'); # ')
	    foreach $t (@terms){
		if($t =~/Skdfile:\s*(\S+)/){
		    $pkg->{skdfile} = $1;
		}
	    }
	}
    }
    close(IN);
    if(@aprdirs > 0){
	$pkg->{baseids}  = \@baseIDs;
	$pkg->{aprdirs} = \@aprdirs;
	$pkg->{outdirs} = \@outdirs;
    }
    $pkg->{stname} = \%stname;
    $pkg->{flag_notice} = \%flag_notice;
    $pkg->{hlist} = \@hlist;
}


sub Work_dir($){
    my $pkg = shift;
    return  $pkg->{komb_work_dir};
}

sub Skd_file($){
    my $pkg = shift;
    return  $pkg->{skdfile};
}

sub Komb_Opt($){
    my $pkg = shift;
    my $opt = sprintf "-SUBID %s -NOMONIT -KOMBDIR %s",
    $pkg->{komb_band},$pkg->{komb_out_dir};
    $opt = $opt . " " . $pkg->{komb_opt}
				if(defined($pkg->{komb_opt}));
    return  $opt;
}

sub Komb_outDir($){
    my $pkg = shift;
    return  $pkg->{komb_out_dir};
}

sub Komb_prog($){
    my $pkg = shift;
    return  $pkg->{komb_prog};
}

sub Lag($){
    my $pkg = shift;
    if(defined($pkg->{lag})){return $pkg->{lag} ;}
    else{ return 0;}
}
sub Integ($){
    my $pkg = shift;
    if(defined($pkg->{integ})){return $pkg->{integ} ;}
    else{ return 0;}
}
sub Stofst($){
    my $pkg = shift;
    if(defined($pkg->{stofst})){return $pkg->{stofst} ;}
    else{ return 0;}
}

sub Aprdir($;$){
    my $pkg = shift;
    my $bid = shift;
    my $aprdirs = $pkg->{aprdirs};

    if( defined($bid) ){
	my $blist = $pkg->{baseids};
	unless(defined(@$blist) && defined(@$aprdirs)){ 
	    print STDERR "Error in Aprdir($bid): Baseline list is not defined.\n";
	    return undef;
	}
	my $i=0;
	for($i=0; $i<@$blist;$i++){  last if($$blist[$i] eq $bid); }
	if($i <@$blist){ return  $$aprdirs[$i];}
	else{  
	    print STDERR "Error in Aprdir: ($bid) is not included.\n";
	    return undef;
	}
    }else{
	if(defined($pkg->{aprdir})){
	    return $pkg->{aprdir}; 
	}else{
	    return $$aprdirs[0];
	};
    }
}

sub Odir($;$){
    my $pkg = shift;
    my $bid = shift;
    my $outdirs = $pkg->{outdirs};
    if( defined($bid) ){
	my $blist = $pkg->{baseids};
	unless(defined(@$blist) && defined(@$outdirs)){ 
	    print STDERR "Error in Outdir($bid): Baseline list is not defined.\n";
	    return undef;
	}
	my $i=0;
	for($i=0; $i<@$blist;$i++){  last if($$blist[$i] eq $bid); }
	if($i <@$blist){ return  $$outdirs[$i];}
	else{  
	    print STDERR "Error in Outdir: ($bid) is not included.\n";
	    return undef;
	}
    }else{
	if(defined($pkg->{odir})){  
	    return $pkg->{odir}; 
	}else { 
	    return $$outdirs[0];
	}
    }
}

sub Tpp($){
    my $pkg = shift;
    return $pkg->{tpp};
}

sub Hlist($){
    my $pkg = shift;
    return $pkg->{hlist};
}

sub Prog($){
    my $pkg = shift;
    return $pkg->{prog};
}

sub Baseids($){
    my $pkg = shift;
    return $pkg->{baseids};
}

## Set Obsetvation data Entry 
sub Set_Oentry($$){
    my ($pkg,$entry) = @_;
    my $oentry = $pkg->{oentry};
    push(@$oentry, $entry);
    $pkg->{oentry} = $oentry;
}


sub O_Ready($$){
    my ($pkg, $entry) = @_;
    my $flag = $pkg->{flag_notice};
    $entry =~m!(\d{4}/\d{3}-\d\d:\d\d:\d\d):(\S+):(\S+)!;
    my $tstr =$1;
    my $stid =$2;
    my $gid =$3;
    $oentry = $pkg->{oentry};
    return 1 
	if($flag->{$stid} ==0 || grep(/$entry/,@$oentry));
    return 0;
}

sub Make_Bentry($$){
    my ($pkg, $entry) = @_;
    unless($entry =~m!(\d{4}/\d{3}-\d\d:\d\d:\d\d):(\S+):(\S+)!){
	print STDERR "Error: entry($entry) is not expected format\n";
	return ();
    }
    my $tstr =$1;
    my $stid =$2;
    my $gid =$3;
    my $bentry = $pkg->{bentry};
    my $baseid = $pkg->{baseids};
    my $flag_notice = $pkg->{flag_notice};

    my $tmp = $tstr . $$baseid[0] . $gid;
    ## If non of baseline entry exist
    unless(defined($bentry->{$tmp})){
	foreach $b (@$baseid){
	    my $tmp = $tstr . $b . $gid;
	    $bentry->{$tmp} =0;
	}
	$pkg->{bentry} = $bentry;
    }
    
    my @ebase;
    print STDERR "Following Scan is ready:------\n" if($pkg->{'MON'});
    foreach $b (@$baseid){
	next unless($b =~/$stid/);
	my @sts  = split(//,$b);
	my ($yst,$xst);
	if($sts[0] eq $stid){
#	    $xst = $sts[0];
	    $yst = $sts[1];
	}elsif($sts[1] eq $stid){
	    $yst = $sts[0];
#	    $xst = $sts[1];
	}
	
	my $otmp = "${tstr}:${yst}:${gid}";
	if( $pkg->O_Ready($otmp) ){
	    $tmp  = "${tstr}:${b}:${gid}";
	    $bentry->{$tmp} =1; ## Ready for processing 
	    push(@ebase, ($tmp));
	    print STDERR " $tmp \n" if($pkg->{'MON'});
	}
    }
    print STDERR "---------------------\n"  if($pkg->{'MON'});
    return @ebase;
}

1;
